Index: code/trunk/bin/def_keybindings.ini
===================================================================
--- code/trunk/bin/def_keybindings.ini	(revision 1881)
+++ code/trunk/bin/def_keybindings.ini	(revision 1887)
@@ -1,63 +1,35 @@
-[KeyBinder]
-KeyUNASSIGNED=openConsole
-KeyESCAPE=exit
-Key1=
-Key2=
-Key3=
-Key4=
-Key5=
-Key6=
-Key7=
-Key8=
-Key9=
-Key0=
-KeyMINUS=
-KeyEQUALS=openConsole
-KeyBACK=
-KeyTAB=cycleNavigationFocus
-KeyQ=moveRoll
-KeyW=moveLongitudinal
-KeyE=scale -1 moveRoll
-KeyR=
-KeyT=
-KeyY=
-KeyU=
-KeyI=
-KeyO=
-KeyP=
-KeyLBRACKET=
-KeyRBRACKET=
-KeyRETURN=
-KeyLCONTROL=
-KeyA=scale -1 moveLateral
-KeyS=scale -1 moveLongitudinal
-KeyD=moveLateral
+[Keys]
+KeyA="scale -1 moveLateral"
+KeyABNT_C1=
+KeyABNT_C2=
+KeyAT=
+KeyAX=
+KeyApostrophe=
+KeyApps=
+KeyB=
+KeyBack=
+KeyBackslash=
+KeyC=
+KeyCalculator=
+KeyCapsLock=
+KeyColon=
+KeyComma=
+KeyConvert=
+KeyD="scale 1 moveLateral"
+KeyDelete=
+KeyDivide=
+KeyDown=
+KeyE="scale -1 moveRoll"
+KeyEnd=
+KeyEquals=
+KeyEscape="exit"
 KeyF=
-KeyG=
-KeyH=scale -0.3 moveYaw
-KeyJ=scale -0.3 movePitch
-KeyK=scale  0.3 movePitch
-KeyL=scale  0.3 moveYaw
-KeySEMICOLON=
-KeyAPOSTROPHE=
-KeyGRAVE=openConsole
-KeyLSHIFT=
-KeyBACKSLASH=
-KeyZ=
-KeyX=
-KeyC=
-KeyV=
-KeyB=
-KeyN=
-KeyM=
-KeyCOMMA=
-KeyPERIOD=
-KeySLASH=
-KeyRSHIFT=
-KeyMULTIPLY=
-KeyLMENU=
-KeySPACE=
-KeyCAPITAL=
-KeyF1=Overlaygroup toggleVisibility Debug
+KeyF1="OverlayGroup toggleVisibility Debug"
+KeyF10=
+KeyF11=
+KeyF12=
+KeyF13=
+KeyF14=
+KeyF15=
 KeyF2=
 KeyF3=
@@ -68,85 +40,204 @@
 KeyF8=
 KeyF9=
-KeyF10=
-KeyNUMLOCK=
-KeySCROLL=
-KeyNUMPAD7=
-KeyNUMPAD8=
-KeyNUMPAD9=
-KeySUBTRACT=
-KeyNUMPAD4=
-KeyNUMPAD5=
-KeyNUMPAD6=
-KeyADD=
-KeyNUMPAD1=
-KeyNUMPAD2=
-KeyNUMPAD3=
-KeyNUMPAD0=
-KeyDECIMAL=
-Key=
-KeyOEM_102=
-KeyF11=
-KeyF12=
-KeyF13=
-KeyF14=
-KeyF15=
-KeyKANA=
-KeyABNT_C1=
-KeyCONVERT=
-KeyNOCONVERT=
-KeyYEN=
-KeyABNT_C2=
-KeyNUMPADEQUALS=
-KeyPREVTRACK=
-KeyAT=
-KeyCOLON=
-KeyUNDERLINE=
-KeyKANJI=
-KeySTOP=
-KeyAX=
-KeyUNLABELED=
-KeyNEXTTRACK=
-KeyNUMPADENTER=openConsole
-KeyRCONTROL=
-KeyMUTE=
-KeyCALCULATOR=
-KeyPLAYPAUSE=
-KeyMEDIASTOP=
-KeyVOLUMEDOWN=
-KeyVOLUMEUP=
-KeyWEBHOME=
-KeyNUMPADCOMMA=
-KeyDIVIDE=
-KeySYSRQ=
-KeyRMENU=
-KeyPAUSE=
-KeyHOME=
+KeyG=
+KeyGrave="openConsole"
+KeyH=
+KeyHome=
+KeyI=
+KeyInsert=
+KeyJ=
+KeyK=
+KeyKana=
+KeyKanji=
+KeyL=
+KeyLeft=
+KeyLeftAlt=
+KeyLeftBracket=
+KeyLeftControl=
+KeyLeftShift=
+KeyLeftWindows=
+KeyLessThan=
+KeyM=
+KeyMail=
+KeyMediaSelect=
+KeyMediaStop=
+KeyMinus=
+KeyMultiply=
+KeyMute=
+KeyMyComputer=
+KeyN=
+KeyNextTrack=
+KeyNoConvert=
+KeyNumLock=
+KeyNumRow0=
+KeyNumRow1=
+KeyNumRow2=
+KeyNumRow3=
+KeyNumRow4=
+KeyNumRow5=
+KeyNumRow6=
+KeyNumRow7=
+KeyNumRow8=
+KeyNumRow9=
+KeyNumpad0=
+KeyNumpad1=
+KeyNumpad2=
+KeyNumpad3=
+KeyNumpad4=
+KeyNumpad5=
+KeyNumpad6=
+KeyNumpad7=
+KeyNumpad8=
+KeyNumpad9=
+KeyNumpadAdd=
+KeyNumpadComma=
+KeyNumpadEnter=
+KeyNumpadEquals=
+KeyNumpadPeriod=
+KeyNumpadSubtract=
+KeyO=
+KeyP=
+KeyPageDown=
+KeyPageUp=
+KeyPause=
+KeyPeriod=
+KeyPlayPause=
+KeyPower=
+KeyPreviousTrack=
+KeyQ="scale 1 moveRoll"
+KeyR=
+KeyReturn=
+KeyRight=
+KeyRightAlt=
+KeyRightBracket=
+KeyRightControl=
+KeyRightShift=
+KeyRightWindows=
+KeyS="scale -1 moveLongitudinal"
+KeyScrollLock=
+KeySemicolon=
+KeySlash=
+KeySleep=
+KeySpace=
+KeyStop=
+KeySystemRequest=
+KeyT=
+KeyTab="cycleNavigationFocus"
+KeyU=
 KeyUP=
-KeyPGUP=
-KeyLEFT=
-KeyRIGHT=
-KeyEND=
-KeyDOWN=
-KeyPGDOWN=
-KeyINSERT=
-KeyDELETE=
-KeyLWIN=
-KeyRWIN=
-KeyAPPS=
-KeyPOWER=
-KeySLEEP=
-KeyWAKE=
-KeyWEBSEARCH=
-KeyWEBFAVORITES=
-KeyWEBREFRESH=
-KeyWEBSTOP=exit
-KeyWEBFORWARD=
-KeyWEBBACK=
-KeyMYCOMPUTER=
-KeyMAIL=
-KeyMEDIASELECT=
-MouseLeft=fire
-MouseRight=
-MouseMiddle=
+KeyUnassigned=
+KeyUnderline=
+KeyUnlabeled=
+KeyV=
+KeyVolumeDown=
+KeyVolumeUp=
+KeyW="scale 1 moveLongitudinal"
+KeyWake=
+KeyWebBack=
+KeyWebFavorites=
+KeyWebForward=
+KeyWebHome=
+KeyWebRefresh=
+KeyWebSearch=
+KeyWebStop=
+KeyX=
+KeyY=
+KeyYen=
+KeyZ=
+Key_084=
+Key_085=
+Key_089=
+Key_090=
+Key_091=
+Key_092=
+Key_093=
+Key_094=
+Key_095=
+Key_096=
+Key_097=
+Key_098=
+Key_099=
+Key_103=
+Key_104=
+Key_105=
+Key_106=
+Key_107=
+Key_108=
+Key_109=
+Key_110=
+Key_111=
+Key_112=
+Key_114=
+Key_115=
+Key_117=
+Key_118=
+Key_119=
+Key_120=
+Key_121=
+Key_123=
+Key_125=
+Key_128=
+Key_129=
+Key_130=
+Key_131=
+Key_132=
+Key_133=
+Key_134=
+Key_135=
+Key_136=
+Key_137=
+Key_138=
+Key_139=
+Key_140=
+Key_141=
+Key_143=
+Key_144=
+Key_154=
+Key_155=
+Key_158=
+Key_159=
+Key_163=
+Key_165=
+Key_166=
+Key_167=
+Key_168=
+Key_169=
+Key_170=
+Key_171=
+Key_172=
+Key_173=
+Key_175=
+Key_177=
+Key_180=
+Key_182=
+Key_185=
+Key_186=
+Key_187=
+Key_188=
+Key_189=
+Key_190=
+Key_191=
+Key_192=
+Key_193=
+Key_194=
+Key_195=
+Key_196=
+Key_198=
+Key_202=
+Key_204=
+Key_206=
+Key_212=
+Key_213=
+Key_214=
+Key_215=
+Key_216=
+Key_217=
+Key_218=
+Key_224=
+Key_225=
+Key_226=
+Key_228=
+
+[MouseButtons]
 MouseButton3=
 MouseButton4=
@@ -154,111 +245,16 @@
 MouseButton6=
 MouseButton7=
+MouseLeft="fire"
+MouseMiddle=
+MouseRight=
+MouseWheel1Down=
 MouseWheel1Up=
-MouseWheel1Down=
+MouseWheel2Down=
 MouseWheel2Up=
-MouseWheel2Down=
-MouseXPos=scale  1 moveYaw
-MouseXNeg=scale -1 moveYaw
-MouseYPos=scale  1 movePitch
-MouseYNeg=scale -1 movePitch
-Empty1Pos=
-Empty1Neg=
-Empty2Pos=
-Empty2Neg=
-JoyAxis1Pos=scale -1 movePitch
-JoyAxis1Neg=scale  1 movePitch
-JoyAxis2Pos=
-JoyAxis2Neg=
-JoyAxis3Pos=
-JoyAxis3Neg=
-JoyAxis4Pos=
-JoyAxis4Neg=
-JoyAxis5Pos=
-JoyAxis5Neg=
-JoyAxis6Pos=
-JoyAxis6Neg=
-JoyAxis7Pos=
-JoyAxis7Neg=
-JoyAxis8Pos=
-JoyAxis8Neg=
-JoyAxis9Pos=scale   1 moveYaw
-JoyAxis9Neg=scale  -1 moveYaw
-JoyAxis10Pos=
-JoyAxis10Neg=
-JoyAxis11Pos=scale -1 moveLongitudinal
-JoyAxis11Neg=scale  1 moveLongitudinal
-JoyAxis12Pos=scale  1 moveLateral
-JoyAxis12Neg=scale -1 moveLateral
-JoyAxis13Pos=
-JoyAxis13Neg=
-JoyAxis14Pos=
-JoyAxis14Neg=
-JoyAxis15Pos=
-JoyAxis15Neg=
-JoyAxis16Pos=
-JoyAxis16Neg=
-JoyAxis17Pos=
-JoyAxis17Neg=
-JoyAxis18Pos=
-JoyAxis18Neg=
-JoyAxis19Pos=
-JoyAxis19Neg=
-JoyAxis20Pos=
-JoyAxis20Neg=
-JoyAxis21Pos=
-JoyAxis21Neg=
-JoyAxis22Pos=
-JoyAxis22Neg=
-JoyAxis23Pos=
-JoyAxis23Neg=
-JoyAxis24Pos=
-JoyAxis24Neg=
-JoyButton0=cycleNavigationFocus
-JoyButton1=
-JoyButton2=
-JoyButton3=
-JoyButton4=
-JoyButton5=
-JoyButton6=scale  1 moveRoll
-JoyButton7=scale -1 moveRoll
-JoyButton8=
-JoyButton9=fire
-JoyButton10=
-JoyButton11=
-JoyButton12=
-JoyButton13=
-JoyButton14=
-JoyButton15=
-JoyButton16=
-JoyButton17=
-JoyButton18=
-JoyButton19=
-JoyButton20=
-JoyButton21=
-JoyButton22=
-JoyButton23=
-JoyButton24=
-JoyButton25=
-JoyButton26=
-JoyButton27=
-JoyButton28=
-JoyButton29=
-JoyButton30=
-JoyButton31=
-JoyPOV1North=
-JoyPOV1South=
-JoyPOV1East=
-JoyPOV1West=
-JoyPOV2North=
-JoyPOV2South=
-JoyPOV2East=
-JoyPOV2West=
-JoyPOV3North=
-JoyPOV3South=
-JoyPOV3East=
-JoyPOV3West=
-JoyPOV4North=
-JoyPOV4South=
-JoyPOV4East=
-JoyPOV4West=
 
+[MouseAxes]
+MouseXNeg="scale 1 moveYaw"
+MouseXPos="scale -1 moveYaw"
+MouseYNeg="scale 1 movePitch"
+MouseYPos="scale -1 movePitch"
+
Index: code/trunk/src/core/ArgumentCompletionFunctions.h
===================================================================
--- code/trunk/src/core/ArgumentCompletionFunctions.h	(revision 1881)
+++ code/trunk/src/core/ArgumentCompletionFunctions.h	(revision 1887)
@@ -35,5 +35,5 @@
 
 #define ARGUMENT_COMPLETION_FUNCTION_DECLARATION(functionname) \
-    ArgumentCompleter* functionname(); \
+    _CoreExport ArgumentCompleter* functionname(); \
     _CoreExport ArgumentCompletionList acf_##functionname
 
Index: code/trunk/src/core/CMakeLists.txt
===================================================================
--- code/trunk/src/core/CMakeLists.txt	(revision 1881)
+++ code/trunk/src/core/CMakeLists.txt	(revision 1887)
@@ -47,4 +47,5 @@
   input/InputCommands.cc
   input/InputManager.cc
+  input/JoyStickDeviceNumberListener.cc
   input/KeyBinder.cc
   input/KeyDetector.cc
Index: code/trunk/src/core/ConfigFileManager.h
===================================================================
--- code/trunk/src/core/ConfigFileManager.h	(revision 1881)
+++ code/trunk/src/core/ConfigFileManager.h	(revision 1887)
@@ -45,6 +45,5 @@
         CFT_Settings,
         CFT_Keybindings,
-        CFT_JoyStickCalibration,
-        CFT_KeyNames
+        CFT_JoyStickCalibration
     };
 
Index: code/trunk/src/core/ConfigValueContainer.cc
===================================================================
--- code/trunk/src/core/ConfigValueContainer.cc	(revision 1881)
+++ code/trunk/src/core/ConfigValueContainer.cc	(revision 1887)
@@ -50,9 +50,9 @@
         @brief Initializes the ConfigValueContainer with defaultvalues.
     */
-    void ConfigValueContainer::init(ConfigFileType type, Identifier* identifier, const std::string& varname)
+    void ConfigValueContainer::init(ConfigFileType type, Identifier* identifier, const std::string& sectionname, const std::string& varname)
     {
         this->type_ = type;
         this->identifier_ = identifier;
-        this->sectionname_ = identifier->getName();
+        this->sectionname_ = sectionname;
         this->varname_ = varname;
         this->callback_ = 0;
@@ -331,5 +331,5 @@
         if (!this->bAddedDescription_)
         {
-            this->description_ = std::string("ConfigValueDescription::" + this->identifier_->getName() + "::" + this->varname_);
+            this->description_ = std::string("ConfigValueDescription::" + this->sectionname_ + "::" + this->varname_);
             AddLanguageEntry(this->description_, description);
             this->bAddedDescription_ = true;
Index: code/trunk/src/core/ConfigValueContainer.h
===================================================================
--- code/trunk/src/core/ConfigValueContainer.h	(revision 1881)
+++ code/trunk/src/core/ConfigValueContainer.h	(revision 1887)
@@ -99,4 +99,5 @@
                 @param type The type of the corresponding config-file
                 @param identifier The identifier of the class the variable belongs to
+                @param sectionname Name of the section the configValue should be put in.
                 @param varname The name of the variable
                 @param defvalue The default-value
@@ -104,7 +105,7 @@
             */
             template <class D, class V>
-            ConfigValueContainer(ConfigFileType type, Identifier* identifier, const std::string& varname, const D& defvalue, const V& value)
-            {
-                this->init(type, identifier, varname);
+            ConfigValueContainer(ConfigFileType type, Identifier* identifier, const std::string& sectionname, const std::string& varname, const D& defvalue, const V& value)
+            {
+                this->init(type, identifier, sectionname, varname);
                 this->initValue((V)defvalue);
             }
@@ -118,7 +119,7 @@
             */
             template <class V>
-            ConfigValueContainer(ConfigFileType type, Identifier* identifier, const std::string& varname, const std::vector<V>& defvalue)
-            {
-                this->init(type, identifier, varname);
+            ConfigValueContainer(ConfigFileType type, Identifier* identifier, const std::string& sectionname, const std::string& varname, const std::vector<V>& defvalue)
+            {
+                this->init(type, identifier, sectionname, varname);
 
                 this->value_ = V();
@@ -266,5 +267,5 @@
 
         private:
-            void init(ConfigFileType type, Identifier* identifier, const std::string& varname);
+            void init(ConfigFileType type, Identifier* identifier, const std::string& sectionname, const std::string& varname);
             void initValue(const MultiType& defvalue);
             void initVector();
Index: code/trunk/src/core/ConfigValueIncludes.h
===================================================================
--- code/trunk/src/core/ConfigValueIncludes.h	(revision 1881)
+++ code/trunk/src/core/ConfigValueIncludes.h	(revision 1887)
@@ -52,5 +52,5 @@
     if (!container##varname) \
     { \
-        container##varname = new orxonox::ConfigValueContainer(CFT_Settings, identifier##varname, #varname, defvalue, varname); \
+        container##varname = new orxonox::ConfigValueContainer(CFT_Settings, identifier##varname, identifier##varname->getName(), #varname, defvalue, varname); \
         identifier##varname->addConfigValueContainer(#varname, container##varname); \
     } \
@@ -71,5 +71,5 @@
     if (!container##varname) \
     { \
-        container##varname = new orxonox::ConfigValueContainer(CFT_Settings, identifier##varname, #varname, defvalue); \
+        container##varname = new orxonox::ConfigValueContainer(CFT_Settings, identifier##varname, identifier##varname->getName(), #varname, defvalue); \
         identifier##varname->addConfigValueContainer(#varname, container##varname); \
     } \
Index: code/trunk/src/core/input/Button.cc
===================================================================
--- code/trunk/src/core/input/Button.cc	(revision 1881)
+++ code/trunk/src/core/input/Button.cc	(revision 1887)
@@ -34,4 +34,5 @@
 
 #include "Button.h"
+
 #include "util/Convert.h"
 #include "util/SubString.h"
@@ -41,8 +42,24 @@
 #include "core/CommandEvaluation.h"
 #include "core/CommandExecutor.h"
-#include "InputCommands.h"
+#include "core/ConfigValueContainer.h"
 
 namespace orxonox
 {
+    /**
+    @note
+        bButtonThresholdUser_: We set it to true so that setConfigValues in KeyBinder sets the value
+        correctly the first time. It is then set to false first and changed later in Button::parse().
+    */
+    Button::Button()
+        : configContainer_(0)
+        , bButtonThresholdUser_(false)
+        , paramCommandBuffer_(0)
+    {
+        nCommands_[0]=0;
+        nCommands_[1]=0;
+        nCommands_[2]=0;
+        clear();
+    }
+
     void Button::clear()
     {
@@ -65,15 +82,28 @@
     }
 
-    void Button::parse(std::vector<BufferedParamCommand*>& paramCommandBuffer)
-    {
+    void Button::readConfigValue()
+    {
+        // create/get ConfigValueContainer
+        if (!configContainer_)
+        {
+            configContainer_ = new ConfigValueContainer(CFT_Keybindings, 0, groupName_, name_, "", name_);
+            configContainer_->callback(this, &Button::parse);
+        }
+        configContainer_->getValue(&bindingString_, this);
+    }
+
+    void Button::parse()
+    {
+        // delete all commands
+        clear();
+
         if (isEmpty(bindingString_))
-        {
-            clear();
             return;
-        }
+
+        // reset this to false first when parsing (was true before when parsing for the first time)
+        bButtonThresholdUser_ = false;
 
         // use std::vector for a temporary dynamic array
         std::vector<BaseCommand*> commands[3];
-
 
         // separate the commands
@@ -112,4 +142,6 @@
                             parseError("Could not parse 'ButtonThreshold' argument. \
                                 Switching to default value.", true);
+                        else
+                            this->bButtonThresholdUser_ = true;
                     }
                     else if (token == "scale")
@@ -152,11 +184,11 @@
 
                     // add command to the buffer if not yet existing
-                    for (unsigned int iParamCmd = 0; iParamCmd < paramCommandBuffer.size(); iParamCmd++)
-                    {
-                        if (getLowercase(paramCommandBuffer[iParamCmd]->evaluation_.getOriginalCommand())
+                    for (unsigned int iParamCmd = 0; iParamCmd < paramCommandBuffer_->size(); iParamCmd++)
+                    {
+                        if (getLowercase((*paramCommandBuffer_)[iParamCmd]->evaluation_.getOriginalCommand())
                             == getLowercase(commandStr))
                         {
                             // already in list
-                            cmd->paramCommand_ = paramCommandBuffer[iParamCmd];
+                            cmd->paramCommand_ = (*paramCommandBuffer_)[iParamCmd];
                             break;
                         }
@@ -165,5 +197,5 @@
                     {
                         cmd->paramCommand_ = new BufferedParamCommand();
-                        paramCommandBuffer.push_back(cmd->paramCommand_);
+                        paramCommandBuffer_->push_back(cmd->paramCommand_);
                         cmd->paramCommand_->evaluation_ = eval;
                         cmd->paramCommand_->paramIndex_ = paramIndex;
@@ -208,12 +240,4 @@
     }
 
-    bool Button::execute(KeybindMode::Enum mode, float abs, float rel)
-    {
-        // execute all the parsed commands in the string
-        for (unsigned int iCommand = 0; iCommand < nCommands_[mode]; iCommand++)
-            commands_[mode][iCommand]->execute(abs, rel);
-        return true;
-    }
-
     inline void Button::parseError(std::string message, bool serious)
     {
Index: code/trunk/src/core/input/Button.h
===================================================================
--- code/trunk/src/core/input/Button.h	(revision 1881)
+++ code/trunk/src/core/input/Button.h	(revision 1887)
@@ -40,4 +40,5 @@
 #include <string>
 #include <vector>
+#include "InputCommands.h"
 
 namespace orxonox
@@ -46,15 +47,20 @@
     {
     public:
-        Button() { nCommands_[0]=0; nCommands_[1]=0; nCommands_[2]=0; clear(); }
+        Button();
         virtual ~Button() { clear(); }
         virtual void clear();
         virtual bool addParamCommand(ParamCommand* command) { return false; }
-        void parse(std::vector<BufferedParamCommand*>& paramCommandBuffer);
+        void parse();
+        void readConfigValue();
         bool execute(KeybindMode::Enum mode, float abs = 1.0f, float rel = 1.0f);
 
+        //! Container to allow for better configValue support
+        ConfigValueContainer* configContainer_;
         //! The configured string value
         std::string bindingString_;
         //! Name of the trigger as strings
         std::string name_;
+        //! Name of the group of input triggers
+        std::string groupName_;
         //! Basic commands for OnPress, OnHold and OnRelease
         BaseCommand** commands_[3];
@@ -64,8 +70,20 @@
         //! Note: This variable is here to have only one parse() function.
         float buttonThreshold_;
+        bool bButtonThresholdUser_;
+        //! Pointer to the list of parametrised commands
+        std::vector<BufferedParamCommand*>* paramCommandBuffer_;
 
     private:
         void parseError(std::string message, bool serious);
     };
+
+    inline bool Button::execute(KeybindMode::Enum mode, float abs, float rel)
+    {
+        // execute all the parsed commands in the string
+        for (unsigned int iCommand = 0; iCommand < nCommands_[mode]; iCommand++)
+            commands_[mode][iCommand]->execute(abs, rel);
+        return true;
+    }
+
 }
 
Index: code/trunk/src/core/input/ExtendedInputState.cc
===================================================================
--- code/trunk/src/core/input/ExtendedInputState.cc	(revision 1881)
+++ code/trunk/src/core/input/ExtendedInputState.cc	(revision 1887)
@@ -92,5 +92,5 @@
     }
 
-    void ExtendedInputState::mouseButtonPressed(MouseButton::Enum id)
+    void ExtendedInputState::mouseButtonPressed(MouseButtonCode::ByEnum id)
     {
         for (unsigned int i = 0; i < mouseHandlers_.size(); i++)
@@ -98,5 +98,5 @@
     }
 
-    void ExtendedInputState::mouseButtonReleased(MouseButton::Enum id)
+    void ExtendedInputState::mouseButtonReleased(MouseButtonCode::ByEnum id)
     {
         for (unsigned int i = 0; i < mouseHandlers_.size(); i++)
@@ -104,5 +104,5 @@
     }
 
-    void ExtendedInputState::mouseButtonHeld(MouseButton::Enum id)
+    void ExtendedInputState::mouseButtonHeld(MouseButtonCode::ByEnum id)
     {
         for (unsigned int i = 0; i < mouseHandlers_.size(); i++)
@@ -118,5 +118,5 @@
     }
 
-    void ExtendedInputState::joyStickButtonPressed(unsigned int joyStickID, JoyStickButton::Enum id)
+    void ExtendedInputState::joyStickButtonPressed(unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
     {
         assert(joyStickID < joyStickHandlers_.size());
@@ -125,5 +125,5 @@
     }
 
-    void ExtendedInputState::joyStickButtonReleased(unsigned int joyStickID, JoyStickButton::Enum id)
+    void ExtendedInputState::joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
     {
         assert(joyStickID < joyStickHandlers_.size());
@@ -132,5 +132,5 @@
     }
 
-    void ExtendedInputState::joyStickButtonHeld(unsigned int joyStickID, JoyStickButton::Enum id)
+    void ExtendedInputState::joyStickButtonHeld(unsigned int joyStickID, JoyStickButtonCode::ByEnum id)
     {
         assert(joyStickID < joyStickHandlers_.size());
Index: code/trunk/src/core/input/ExtendedInputState.h
===================================================================
--- code/trunk/src/core/input/ExtendedInputState.h	(revision 1881)
+++ code/trunk/src/core/input/ExtendedInputState.h	(revision 1887)
@@ -75,13 +75,13 @@
         void keyHeld    (const KeyEvent& evt);
 
-        void mouseButtonPressed (MouseButton::Enum id);
-        void mouseButtonReleased(MouseButton::Enum id);
-        void mouseButtonHeld    (MouseButton::Enum id);
+        void mouseButtonPressed (MouseButtonCode::ByEnum id);
+        void mouseButtonReleased(MouseButtonCode::ByEnum id);
+        void mouseButtonHeld    (MouseButtonCode::ByEnum id);
         void mouseMoved         (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize);
         void mouseScrolled      (int abs, int rel);
 
-        void joyStickButtonPressed (unsigned int joyStickID, JoyStickButton::Enum id);
-        void joyStickButtonReleased(unsigned int joyStickID, JoyStickButton::Enum id);
-        void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButton::Enum id);
+        void joyStickButtonPressed (unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
+        void joyStickButtonReleased(unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
+        void joyStickButtonHeld    (unsigned int joyStickID, JoyStickButtonCode::ByEnum id);
         void joyStickAxisMoved     (unsigned int joyStickID, unsigned int axis, float value);        void updateTickables();
 
Index: code/trunk/src/core/input/HalfAxis.cc
===================================================================
--- code/trunk/src/core/input/HalfAxis.cc	(revision 1881)
+++ code/trunk/src/core/input/HalfAxis.cc	(revision 1887)
@@ -35,5 +35,4 @@
 #include "HalfAxis.h"
 #include "core/CommandEvaluation.h"
-#include "InputCommands.h"
 
 namespace orxonox
@@ -68,11 +67,3 @@
         return true;
     }
-
-    bool HalfAxis::execute()
-    {
-        bool success = true;
-        for (unsigned int i = 0; i < nParamCommands_; i++)
-            success = success && paramCommands_[i]->execute(absVal_, relVal_);
-        return success;
-    }
 }
Index: code/trunk/src/core/input/HalfAxis.h
===================================================================
--- code/trunk/src/core/input/HalfAxis.h	(revision 1881)
+++ code/trunk/src/core/input/HalfAxis.h	(revision 1887)
@@ -38,4 +38,5 @@
 #include "core/CorePrereqs.h"
 #include "Button.h"
+#include "InputCommands.h"
 
 namespace orxonox
@@ -67,4 +68,12 @@
         bool hasChanged_;
     };
+
+    inline bool HalfAxis::execute()
+    {
+        bool success = true;
+        for (unsigned int i = 0; i < nParamCommands_; i++)
+            success = paramCommands_[i]->execute(absVal_, relVal_) && success;
+        return success;
+    }
 }
 
Index: code/trunk/src/core/input/InputBuffer.h
===================================================================
--- code/trunk/src/core/input/InputBuffer.h	(revision 1881)
+++ code/trunk/src/core/input/InputBuffer.h	(revision 1887)
@@ -44,5 +44,5 @@
     public:
         BaseInputBufferListenerTuple(bool bListenToAllChanges, bool bOnlySingleInput,
-            bool trueKeyFalseChar, char _char, KeyCode::Enum key)
+            bool trueKeyFalseChar, char _char, KeyCode::ByEnum key)
             : bListenToAllChanges_(bListenToAllChanges), bOnlySingleInput_(bOnlySingleInput),
               trueKeyFalseChar_(trueKeyFalseChar), char_(_char), key_(key)
@@ -54,5 +54,5 @@
         bool trueKeyFalseChar_;
         char char_;
-        KeyCode::Enum key_;
+        KeyCode::ByEnum key_;
     };
 
@@ -62,5 +62,5 @@
     public:
         InputBufferListenerTuple(T* listener, void (T::*function)(), bool bListenToAllChanges,
-            bool bOnlySingleInput, bool trueKeyFalseChar, char _char, KeyCode::Enum key)
+            bool bOnlySingleInput, bool trueKeyFalseChar, char _char, KeyCode::ByEnum key)
             : BaseInputBufferListenerTuple(bListenToAllChanges, bOnlySingleInput, trueKeyFalseChar, _char, key),
               listener_(listener), function_(function)
@@ -109,5 +109,5 @@
 
             template <class T>
-            void registerListener(T* listener, void (T::*function)(), KeyCode::Enum key)
+            void registerListener(T* listener, void (T::*function)(), KeyCode::ByEnum key)
             {
                 InputBufferListenerTuple<T>* newTuple = new InputBufferListenerTuple<T>(listener, (void (T::*)())function, false, true, true, '\0', key);
@@ -115,5 +115,5 @@
             }
             template <class T>
-            void registerListener(T* listener, void (T::*function)() const, KeyCode::Enum key)
+            void registerListener(T* listener, void (T::*function)() const, KeyCode::ByEnum key)
             {
                 InputBufferListenerTuple<T>* newTuple = new InputBufferListenerTuple<T>(listener, (void (T::*)())function, false, true, true, '\0', key);
@@ -178,5 +178,5 @@
             unsigned int cursor_;
 
-            KeyCode::Enum lastKey_;
+            KeyCode::ByEnum lastKey_;
             float timeSinceKeyPressed_;
             float timeSinceKeyRepeated_;
Index: code/trunk/src/core/input/InputCommands.cc
===================================================================
--- code/trunk/src/core/input/InputCommands.cc	(revision 1881)
+++ code/trunk/src/core/input/InputCommands.cc	(revision 1887)
@@ -65,19 +65,4 @@
 
     // ###############################
-    // #####    SimpleCommand    #####
-    // ###############################
-
-    /**
-    @brief
-        Executes a simple command with no additional paramters.
-    @return 
-        True if command execution was successful, false otherwise.
-    */
-    bool SimpleCommand::execute(float abs, float rel)
-    {
-        return evaluation_.execute();
-    }
-
-    // ###############################
     // #####    ParamCommand     #####
     // ###############################
Index: code/trunk/src/core/input/InputCommands.h
===================================================================
--- code/trunk/src/core/input/InputCommands.h	(revision 1881)
+++ code/trunk/src/core/input/InputCommands.h	(revision 1887)
@@ -68,4 +68,15 @@
     };
 
+    /**
+    @brief
+        Executes a simple command with no additional paramters.
+    @return 
+        True if command execution was successful, false otherwise.
+    */
+    inline bool SimpleCommand::execute(float abs, float rel)
+    {
+        return evaluation_.execute();
+    }
+
     class _CoreExport ParamCommand : public BaseCommand
     {
